function ISRILsync()
{
	// -- Define API Connection -- //
	//this.apiURL	=	'http://dent.readitlaterlist.com/v1/';
	this.apiURL	=	'https://readitlaterlist.com/v1/';
	
	// -- Timing -- //
	this.syncInterval;
	this.syncIntervalMain = 15 * (60 * 1000); //minutes
	this.syncTime;
	this.syncTimeInc = 1; //default wait before sending changes to list
	this.syncTimeIncBatch = 5; //default wait after click-to-save mode/right click save changes
	this.syncTimeWaitResolve = 20; //default wait if needing to resolve/download link 
	
	this.usyncInterval = 6 * (60 * 60 * 1000); //hours
	this.usyncIntSteps = 0;
	
	this.queueWriteInt = 500; //Time to wait before running through adding items to queue.  This offset allows mass changes to skip waiting for writes to the DB.


	this.tagUpdateTimeouts = new Object();
	this.startUpSync;
	this.updatesTmp = new Object();
	this.writeQueue = new Object();
	
}

ISRILsync.prototype = {
	
	_init : function() {
		ISRILglobals.syncInterval = setTimeout('ISRILsync.sendUpdates()', ISRILsync.syncIntervalMain); //attempt to send every 15 minutes
		if (!ISRILglobals.inited) {
			ISRILglobals.startUpSync = setTimeout('ISRILsync.getUpdatesStart();', 10000); //get updates 10 seconds after startup
			ISRILsync.uSyncIntervalCheck();
		}
		ISRILglobals.noSyncId = false;
	},
	
	// --- //
	
	ReadySync : function(inc) {
		if (ISRILsync.syncTime) { clearTimeout(ISRILsync.syncTime); }
		ISRILsync.syncTime = setTimeout('ISRILsync.sendUpdates()', (inc?inc:ISRILsync.syncTimeInc)*1000 );
		ISRILglobals.noSyncId = null;
	},
	uSyncIntervalCheck : function() {
		if (ISRILsync.usyncIntSteps >= ISRILsync.usyncInterval / ISRILsync.syncIntervalMain) {
			ISRILsync.usyncIntSteps = 0;
			ISRILsync.getUpdatesStart();	
		} else {
			ISRILsync.usyncIntSteps++;	
		}
		ISRILglobals.usyncInterval = setTimeout('ISRILsync.uSyncIntervalCheck();', ISRILsync.syncIntervalMain); //check uSync interval
	},
	
	// --- //
	
	_reset : function() {
		ISRILprefs.setPref('temp-sync-inserts', '');
		ISRILprefs.setPref('temp-sync-updates', '');
		ISRILprefs.setPref('temp-sync-tagUpdates', '');
		if (ISRILsync.syncTime) { clearTimeout(ISRILsync.syncTime); }
		ISRILglobals.noSyncId = null;
	},
	
	// -- Database Sync Queue -- //
	
	Queue : function(id, type, url, delay) {		
		clearInterval(ISRILsync.queueWriteTO);
		ISRILsync.writeQueue[id] = {id:id, type:type,url:url?url:'',delay:delay?delay:null};
		ISRILsync.queueWriteTO = setTimeout('ISRILsync.QueueWrite()', ISRILsync.queueWriteInt );
	},
	
	QueueWrite : function() {
		if (ISRILprefs.prefB('feed')) {
			for(var i in ISRILsync.writeQueue) {
				var item = ISRILsync.writeQueue[i];
				if (item) {
					ISRIL.d(item.id + '---' + item.type + '---' + item.url);
					var time = ISRIL.now();
					var sql = "REPLACE INTO ril_sync_queue (id, type, dateUpdated, url) VALUES (?1, ?2, "+time+", ?3)"
					var statement = ISRIL.DB.createStatement(sql);
					    statement.bindInt32Parameter(0, item.id);
					    statement.bindUTF8StringParameter(1, item.type);
					    statement.bindUTF8StringParameter(2, item.url?item.url:'');	
					    statement.execute();	
					    statement.reset();	
					ISRILsync.ReadySync(item.delay?item.delay:null);
				}
			}	
		}
		ISRILsync.writeQueue = new Object();
		ISRILxul.UpdateViews();
	},
	
	QueueNew : function(id, url, delay) {
		if (id && id != ISRILglobals.noSyncId) {
			ISRILsync.Queue(id, 'new', url?url:null, delay?delay:null);
			ISRIL.CacheAdd(id, url);
		}
	},

	QueueUpdate : function(id, type, url) {
		if (!url) { url = url = ( (ISRILglobals.ListCache[id]) ? (ISRILglobals.ListCache[id]) : (ISRIL.sBookmarks.getBookmarkURI(id).spec) ); }
		if (id && id != ISRILglobals.noSyncId) {
			ISRILsync.Queue(id, type, url);		
			ISRILglobals.CacheStale = true;
		}
	},
	
	QueueUpdateTags : function(id, now) {
		
		//Because the modified listener fires for every tag that's updated, need to use a timeout to wait till it's done before adding to queue, or it's slow
		if (id && id != ISRILglobals.noSyncId) {
			if (!now) { 
				if (ISRILsync.tagUpdateTimeouts[id]) { 
					clearTimeout( ISRILsync.tagUpdateTimeouts[id] );
				}
				ISRILsync.tagUpdateTimeouts[id] = setTimeout('ISRILsync.QueueUpdateTags('+id+',true)', 333);
				//The timeout is needed because this is called one by one for every tag, it avoids sending the server duplicate updates
			} else {
				ISRILsync.QueueUpdate(id, 'update_tags');
			}
		}
	},
	
	// -- //
	
	ClearQueue : function(time) {
		ISRIL.DB.executeSimpleSQL("DELETE FROM ril_sync_queue WHERE dateUpdated <= " + time);
	},
	
	// -- Assemble Querystrings for request types -- //
	
	GetQueueType : function(type) {
		var items = {};
		var sql = "SELECT id, url FROM ril_sync_queue WHERE type = ?1"
		var statement = ISRIL.DB.createStatement(sql);
		    statement.bindUTF8StringParameter(0, type);
		while (statement.executeStep()) {
			try {
				url = statement.getUTF8String(1);
				id = statement.getInt32(0);
				items[ id ] = url ? url : ISRIL.sBookmarks.getBookmarkURI(id).spec;
			} catch(e) { ISRIL.d('ERROR: ' + id); }
		}
		statement.reset();
		return items;
	},
	
	GetQueryNew : function() {
		var items = new Object();
		var ids = ISRILsync.GetQueueType( 'new' );
		for(var i in ids) {
			try {
				items[i] = {
					url	:	ISRIL.e( ids[i] ),
					title	:	ISRIL.e( ISRIL.sBookmarks.getItemTitle(i) ),
					tags	:	ISRIL.e( ISRIL.sTags.getTagsForURI(ISRIL.uri(ids[i]), {}).join(',') )
				}
			} catch(e) { ISRIL.d('ERROR: ' + id); }
		}
		return items;
	},
	
	GetQueryRead : function() {
		var items = new Object();
		var ids = ISRILsync.GetQueueType( 'read' );
		for(var i in ids) {
			try {
				items[i] = {url : ISRIL.e( ids[i] ) };
			} catch(e) { ISRIL.d('ERROR: ' + id); }
		}
		return items;
	},
	
	GetQueryUpdateTitle : function() {
		var items = new Object();
		var ids = ISRILsync.GetQueueType( 'update_title' );
		for(var i in ids) {
			try {
				items[i] = {
					url	:	ISRIL.e( ids[i] ),
					title	:	ISRIL.e( ISRIL.sBookmarks.getItemTitle(i) )
				}
			} catch(e) { ISRIL.d('ERROR: ' + id); }
		}
		return items;
	},
	
	GetQueryUpdateTags : function() {
		var items = new Object();
		var ids = ISRILsync.GetQueueType( 'update_tags' );
		for(var i in ids) {
			try {
				items[i] = {
					url	:	ISRIL.e( ids[i] ),
					tags	:	ISRIL.e( ISRIL.sTags.getTagsForURI(ISRIL.uri(ids[i]), {}).join(',') )
				}
			} catch(e) { ISRIL.d('ERROR: ' + id); }
		}
		return items;
	},
	
	QueueExists : function() {
		var sql = "SELECT COUNT(*) FROM ril_sync_queue"
		var statement = ISRIL.DB.createStatement(sql);
		statement.executeStep();
		var cnt = statement.getInt32(0);
		statement.reset();
		return cnt;
	},
	
	// -- Query API -- //
	
	sendUpdates : function(callbackArg) {
		ISRIL.d('SEND----------');		
		ISRILxul.UpdateViews();
		
		//If connection failure TO - wait???  - remove this??
		if (ISRILsync.connectFailure) {
			return false;
		} 

		//If we are online and user has opted to send data to feed, step in
		if (navigator.onLine && ISRILprefs.prefB('feed') && ISRILsync.QueueExists() > 0) {
			
			ISRILsync.syncStartedTime = ISRIL.now();
			
			//Get Update Query Strings
			ISRILsync.updatesTmp = new Object();
			var New 	= 	Array('&new=' 	, ISRIL.json.encode( ISRILsync.GetQueryNew() ));
			var Read 	= 	Array('&read=' 	, ISRIL.json.encode( ISRILsync.GetQueryRead() ));
			var UpdateTitle = 	Array('&update_title=', ISRIL.json.encode( ISRILsync.GetQueryUpdateTitle() ));
			var UpdateTags 	= 	Array('&update_tags=' , ISRIL.json.encode( ISRILsync.GetQueryUpdateTags() )); 
			
		
			//If we have at least one thing to update, do it			
			var ajax = new ISRILajax();
			params = ISRILsync.lin()+New.join('')+Read.join('')+UpdateTitle.join('')+UpdateTags.join('')+'&callback[]='+((callbackArg)?(callbackArg):(''));
			ISRIL.d(params);
			ajax.post(ISRILsync.apiURL + 'send', ISRILsync.sendUpdatesCallback, params);
			return true;
			
		}
		
		//If sync was not attempted for one of the reasons above, carry on as if it happened
		ISRILsync.sendUpdatesDone(callbackArg);
	},
	
	/*
	 Expected:
	 JSON Object:
		status - 1 if success, 0 if failed
		callback - general arguments being passed through from original ajax request
		error - if there was a specific error
		updated_login - updated login info if using old feed id/pass
		msg - only pertains if error is for server maintenance
	Does:
		-Check for errors
		-Clear Annotations for updates
	*/
	sendUpdatesCallback : function(r) {
		//ISRIL.d('sendUpdatesCallback: ' + r);
		var data = {};
		
		try {		
			var data = ISRIL.json.decode(r);
			if (!data.error) { //yay, we made it
				
				//Clear out the sync queue
				ISRILsync.ClearQueue(ISRILsync.syncStartedTime);
				
				//If Login is being changed
				if (data.updated_login) {
					ISRIL.d('update login');
					ISRILsync.UpdateLogin(data.updated_login.feed_id, data.updated_login.pass)
				}
				
				//Pass through to callback argument handler
				return ISRILsync.sendUpdatesDone(data.callback);
			}
		} catch(e) {
			data.error = r.length > 0 ? 1 : 0;
		}
		
		//If here, then there was a problem, so we go through possible errors	
		
		return ISRILsync.whatError(data);
	},
	
	sendUpdatesDone : function(c) {				
		ISRILsync._reset();
		
		//If we should get updates after this, let's do it
		switch (c + '') {
			case('get'):
				ISRILsync.getUpdates();
				break;
			
			case('shutdown'):
				ISRIL.shutdown();
				break;
			
		}
	},
	
	// - //
	
	getUpdatesStart : function(hs) {
		ISRILsync.hardSync = hs;
		ISRILsync.connectFailure = false; //reset if set, since this is a manual check
		ISRILsync.sendUpdates('get');
	},
	
	getUpdates : function() {
		ISRIL.d('GET-----------');
		
		//If we are online and the user has opted to sync, then step in
		if (navigator.onLine && ISRILprefs.prefB('sync')) {		
			var params = ISRILsync.lin();
			
			if (!ISRILsync.hardSync) {
				params	+= '&since=' + ISRILprefs.pref('last_get');
			}
			
			var ajax = new ISRILajax();	
			ajax.post(ISRILsync.apiURL + 'get', ISRILsync.getUpdatesCallback, params);
			ISRIL.d(params);
			return true;
		}
	},
	
	/*
	 Expected:
	 JSON Object:
		status - (1 - new items sent, 2 - no new items, you are up-to-date)
		list - list of items (including url, title, tags)
		time - server time of this request
		error - if there was a specific error
		msg - only pertains if error is for server maintenance
	Does:
		-Check for errors
		-Process updates
	*/
	getUpdatesCallback : function(r) {
		ISRIL._func = ISRILsync.getUpdatesCallbackBatch;
		ISRIL._args = arguments;	
		ISRIL.sBookmarks.runInBatchMode(ISRIL, null);
	},
	
	getUpdatesCallbackBatch : function(r) {
		ISRIL.d('GET RESPONSE: ' + r);
		var data = {};
		var errorMsg = false;
		
		if (ISRILsync.hardSync) {
			ISRIL.GetList();
		}
		var compare = ISRILglobals.ListCache;
		
		try {
			var data = ISRIL.json.decode(r);
			if (!data.error) { //yay, we made it
				
				if (data.status == 1) {
					/*
					 Syncing Logic:
					Read on server?
						On local list?
							Remove - do not send as update
							Remove from HardSync Compare List
					Unread on server?
						On local list?
							Title or Tags Different?
								Update - do not send as update
								Remove from HardSync Compare List
					       Off list?
						       Add to list
					*/

					for(var i in data.list) {
						var item = data.list[i];
						ISRIL.d('-----');
						ISRIL.d(item.url);
						try { var itemId = ISRIL.InList( item.url ); } catch(err) {
							ISRIL.d('InList Error: ' + err);
						}
						if (item.status == 1) { //read on server?
							ISRIL.d('read');
							if (itemId) { //on local list?
								ISRIL.d('on list');
								ISRIL.MarkAsRead(itemId, true, null, true);
								compare[itemId] = false;
							}
						} else { //unread on server?
							if (itemId) { //on local list?
								ISRIL.d('unread - on list');
								ISRILglobals.noSyncId = itemId;
								ISRIL.sBookmarks.setItemTitle(itemId , item.title);
								if (item.tags) {
									ISRIL.d('tags');	
									var uri = ISRIL.uri( item.url );
									//ISRIL.sTags.untagURI( uri, ISRIL.sTags.getTagsForURI( uri, {}), 1); //remove all tags
									ISRIL.d('TAGS-');
									ISRIL.d(item.tags);
									ISRIL.d('TAGS---');
									ISRIL.d(ISRIL.TrimArray(item.tags));
									ISRIL.sTags.tagURI( uri, ISRIL.TrimArray(item.tags), 1 ); //add all tags	
								}
								compare[itemId] = false;
							} else { //not on local list
								ISRIL.d('add');						
								//Add Items					
								var bookmarkId = ISRIL.Save(item.url, item.title, true);
								ISRILglobals.noSyncId = bookmarkId;
								ISRIL.sBookmarks.setItemDateAdded(bookmarkId, item.time_added*1000*1000);		
								
								//Update Tags
								if (item.tags) {
									ISRIL.d('add tags');	
									var uri = ISRIL.uri( ISRIL.sBookmarks.getBookmarkURI(bookmarkId).spec );
									ISRIL.sTags.tagURI( uri, ISRIL.TrimArray(item.tags), 1 ); //add all tags
								}
							}
						}
					}					
					
				}
				ISRIL.d('EXIT');
				//list was or is now up-to-date
				
				if (ISRILsync.hardSync) {
					for(i in compare) {
						if (compare[i]) { ISRILsync.Queue(i, 'new', compare[i]); }
					}
					ISRILsync.hardSync = false;
				}
				
				//update last sync time
				ISRILprefs.setPref('last_get', data.time);
				
				if (!ISRILxul.List.hidden) {
					ISRILsync.ReadingListSyncDone();
				}
				
				return true;
			}
		} catch(err) {
			errorMsg = err;
			ISRIL.d('SYNC ERROR: '+errorMsg)
			data.error = r.length > 0 ? 1 : 0;
		}
		
		//If here, then there was a problem, so we go through possible errors	
		
		return ISRILsync.whatError(data, errorMsg);
	},
	
	// --- //
	
	whatError : function(data, err) {
		switch(data.error) {
			case(1):
				return ISRILsync.ErrorSync(err);
			
			case(2):
				return ISRILsync.ErrorLogin();
			
			case(3):
				return ISRILsync.ErrorMaintenance(data.msg);
			
			default:
				return ISRILsync.ErrorConnection();
		}
	},
		
	// --- //
	
	UpdateLogin : function(a,b) {
		ISRILprefs.setPref( 'feed-id-'+ISRILprefs.pref('feed-which') , a );
		ISRILprefs.setPref( 'sync-'+ISRILprefs.pref('feed-which') , b );
		ISRILprefs.setPref( 'sync',	true);
	},
	CheckLogin : function(a,b,callback) {
		var ajax = new ISRILajax();
		ajax.post(ISRILsync.apiURL + 'login', callback, ISRILsync.lin(a,b));
	},
	
	// -- //
	
	ErrorSync : function(err) {
		ISRILxul.ListErrorSet(true, {txt:ISRIL.l('SyncError'), txt2:err?ISRIL.l('ErrorMayHelp')+"\n\n"+err:'', onclk:'ISRILsync.ReadingListSync()' });
	},	
	ErrorLogin : function() {
		ISRILxul.ListErrorSet(true, {txt:ISRIL.l('CannotSync'), onclk:'ISRILxul.OpenOptions(\'sync\');', buttonTxt:ISRIL.l('SyncOptions') } );
	},
	ErrorConnection : function() {
		ISRILxul.ListErrorSet(true, {txt:ISRIL.l('CannotConnect'), onclk:'ISRILsync.ReadingListSync()' });
	},
	ErrorMaintenance : function(msg) {
		ISRILxul.ListErrorSet(true, {txt:msg?msg:ISRIL.l('MaintenanceModeDefault'), onclk:'ISRILsync.ReadingListSync()'});
	},
	
	// --- //
	lin : function(a,b) { return 'feed_id=' + ( (a) ? (a):(ISRILsync.feedId()) ) + '&pass=' + ( (b) ? (b):(ISRILsync.syncP()) ); },
	
	feedId : function() {
		return ISRILprefs.pref('feed-id-'+ISRILprefs.pref('feed-which'));
	},
	
	syncP : function() {
		return ISRILprefs.pref('sync-'+ISRILprefs.pref('feed-which'));
	},
	
	// --- //
	
	ReadingListSync : function(hs) {
		ISRILxul.bip('Empty').hidden = true;
		ISRILxul.bip('ListFooter').hidden = true;
		ISRILxul.ListNotifySet('Sync', false);
		ISRILxul.ListMsgSet(true, 'Syncing');
		ISRILsync.getUpdatesStart(hs);
	},
	ReadingListSyncDone : function() {
		ISRILxul.bip('ListFooter').hidden = false;
		ISRILxul.FillList(false, true);
		ISRILxul.ListNotifySet('Sync', true);
		ISRILxul.ListMsgSet(false);
	},
	
	// --- //
	
	GetAFeed : function(force) {
		if (ISRILprefs.pref('feed-id-default')==0 || force) {
			var ajax = new ISRILajax();
			ajax.post(ISRILsync.apiURL + 'newUser', ISRILsync.GetAFeedDone, 'hello=1');
		}
	},
	GetAFeedDone : function(r) {
		var data = {};
		try {
			var data = ISRIL.json.decode(r);
		} catch(err) {}
		
		if (data.msg) {
			return ISRILxul.sPrompt.alert(window, ISRIL.l('ProblemCreating'), ISRIL.l('ProblemCreatingMsg') + "\n\n" + data.msg );			
		}
		if (data.status >= 1) {	
			ISRILprefs.setPref('feed', true);
			ISRILprefs.setPref('feed-id-default', data.feed_id);
			ISRILprefs.setPref('sync-default', data.pass);
			ISRILsync.getUpdatesStart(true);
			if (data.status == '2') {
				ISRILprefs.setPref('sync', true);
			}
		} else {
			ISRILprefs.setPref('feed', false);
			ISRILxul.sPrompt.alert(window, ISRIL.l('ProblemCreating'), ISRIL.l('ProblemCreatingMsg') );
		}
	},
	GetIn : function() {
		var ajax = new ISRILajax();
		ajax.post('https://readitlaterlist.com/login_process-ril.php', ISRILsync.GetInDone, ISRILsync.lin());	
	},	
	GetInDone : function(r) {
		
	}
	
}

var ISRILsync = new ISRILsync();


function ISRILajax()
{
	
}

ISRILajax.prototype = {
	post : function (uri, callback, parameters) {
		this.callback = callback;
		this.transport = new XMLHttpRequest();
		this.osc(this);
		this.transport.open("POST",uri,true);
		this.transport.setRequestHeader("User-Agent" , 'ISRIL '+ISRIL.v);
		this.transport.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
		this.transport.send(parameters); 
	},
		
	osc : function (ajaxObj) {
		ajaxObj.transport.onreadystatechange = function() {
			try {
				switch(ajaxObj.transport.readyState) {
					case(4): ajaxObj.callback(ajaxObj.transport.responseText);
				}
			}
			catch( e ) { //server error
				//alert('server error');
			}
		}	
	},
}